Subject: Re: [patch net-next-2.6] net: reinject arps into bonding slave instead of master

From: Nicolas de Pesloüan<[email-masked]>
Date: Thu, 10 Mar 2011 21:44:53 +0100

Le 10/03/2011 07:48, Jiri Pirko a écrit :
>> But for all others setups, where there exist some net_devices before
>> the "untagging" one, you would face some troubles. For example, with
>> eth0+eth1 ->  br0 ->  br0.100, you cannot untag before entering
>> __netif_receive_skb. If you do so, the bridge would receive untagged
>> frame and if the frame is not for the local host, the bridge would
>> forward an untagged frame while it is expected to forward a tagged
>> one. Even if the bridge is in a position to know the frame *was*
>> tagged, we cannot expect the bridge to do special processing to
>> handle this situation. Doing so would break layering.
>
> I disagree.
> eth0 ->  untag on early __netif_receive_skb (sets up skb->vlan_tci)
>             ->rx_handler of bridge
> ->br0 ->  tag is detected by vlan_tx_tag_present()
>             ->  reinject to __netif_receive_skb with skb->dev == br0.100

For local delivery, is should work.

But if the bridge must forward the frame to another host (bridges are designed for such things :-)), 
it will have to insert the vlan header back into the frame. I don't understand how it could work 
automagically in this situation.

> This way the flow would be very similar to vlan-hw-accel, am I right?

So your point is to remove any 802.1Q header in any ingres frame, whatever the local interface 
setup. Right?

How would this support nested vlan headers?

eth0 -> eth0.100 -> eth0.100.200 -> eth0.100.200.300.

Who will choose eth0.100.200.300 as the last skb->dev?

> I have following patch in mind. Note it's raw DRAFT.

I need to take some time to review your patch.

In the mean time, what is the status of the whole patch series? Can we expect an ACK from someone?

	Nicolas.